#!/usr/bin/env python
# This file is used to automatically extract the SVN revision number and
# create a C include file.

#includes
from os.path import isfile
from sys import exit

#Get our SVN entries file - this has the rev # in it
svnfile=open('../.svn/entries', 'r')

svncontent=svnfile.readlines(10)

revision=svncontent[3]

#Write out our data
if isfile("svn-revision.h"):
    infile = file("svn-revision.h", "r")
    for ln in infile:
        if ln == "#define BUILD_SVN_REVISION " + revision + "\n":
            infile.close()
            exit()

outfile = file("svn-revision.h", "w+")
outfile.write("// This file is automatically generated by make-svn-rev-header.py\n")
outfile.write("// Do not modify or add to revision control\n\n")
outfile.write("#define BUILD_SVN_REVISION " + revision + "\n")
outfile.close()
